(******************************************************************************)
(** * SRAG simulates SRAL: lose step   *)
(******************************************************************************)

Require Import Omega.
Require Import Hahn.

Require Import Basic.
Require Import Subseq.

Require Import Labels Events Execution.
Require Import SRAL SRAG.
Require Import Write_lists Match.

Set Implicit Arguments.
Remove Hints plus_n_O.

Lemma GsimL_lose (st st' : State)
          (G : execution) (MATCH: SGmatch st G)
          (SRAL: SRAL_step st st' None) :
          SGmatch st' G.
Proof.
inversion SRAL; subst.
red; ins; splits; eauto.
by apply MATCH.
ins.
specialize (SUB _ _ IN); desc.
rename ol into ol'.
rename ol0 into ol.
apply subseq_mapping in SUB0; desc.
red in MATCH; desc.
specialize (SMATCH _ _ SUB); desc.
exists (fun n => wl (f n)).
red in SMATCH; desc.
red in WL_WF; desc.
red in WL_CONS; desc.
red in SUB0; desf.
red; splits; red; splits.
- unfolder; ins.
  eapply WL_W.
  unfold in_wl in *; desc.
  exists (f n); splits; eauto.
- unfolder; ins.
  eapply WL_G.
  unfold in_wl in *; desc.
  exists (f n); splits; eauto.
- ins.
  specialize (NTH _ LEN0).
  rewrite WL_TID; eauto.
  erewrite nth_error_nth; try edone.
  rewrite <- NTH.
  by apply nth_error_nth_len.
- ins.
  specialize (NTH _ LEN0).
  rewrite WL_LOC; eauto.
  erewrite nth_error_nth; try edone.
  rewrite <- NTH.
  by apply nth_error_nth_len.
- ins.
  specialize (NTH _ LEN0).
  rewrite WL_VAL; eauto.
  erewrite nth_error_nth; try edone.
  rewrite <- NTH.
  by apply nth_error_nth_len.
- ins; intro.
  specialize (NTH _ LEN0).
  eapply WL_RMW; eauto.
  erewrite nth_error_nth; try edone.
  rewrite <- NTH.
  by apply nth_error_nth_len.
- unfolder; ins; desc.
  unfold in_wl in *; desc.
  eapply WL_D.
  unfolder; splits; eauto 12.
- unfolder; ins; desc.
  unfold order_wl in *; desc.
  eapply WL_O.
  unfolder; splits; eauto 12.
Qed.
